class Tesela{

  float a, hTercio, distanciaMouse;
  float xpos, ypos, x1, y1, z1, x2, y2, z2, x3, y3, z3;
  float rot, rotTarget;
  int giros, tipo;
  boolean parada, girando, sobre;

  Tesela(float _a, float _xpos, float _ypos, boolean _parada ){
    a = _a;
    xpos = _xpos;
    ypos = _ypos;
    parada = _parada;
    giros = int(random(4));
    rot = TWO_PI/3.0 * float(giros);
    tipo = int(random(7)) + 1;
  }

  void dibujar(){
    hTercio = sqrt(3)*a/6;
    float dif;
    if(girando){
      dif = rotTarget - rot;
      rot += dif * 0.2;
      if (dif < 0.01){
        rot = rotTarget;
        girando = false;
      }
    }
    
    pushMatrix();
    {
      translate(xpos, ypos);
      if(!parada){
        rotate(PI/3);
      }
      rotate(rot);
      
      if (sobre){
        fill(#FFF9F7);
        strokeWeight(0.25);
        stroke(#E51515);
        beginShape();
        vertex(-a/2, hTercio);
        vertex(a/2, hTercio);
        vertex(0, -2*hTercio);
        endShape(CLOSE);
        noFill();
      }
      else{
        noFill();
      }
      if(lineas && !sobre){
        strokeWeight(0.25);
        stroke(100);
        beginShape();
        vertex(-a/2, hTercio);
        vertex(a/2, hTercio);
        vertex(0, -2*hTercio);
        endShape(CLOSE);
      }
      if(fondo && !sobre){
        fill(255);
        noStroke();
        beginShape();
        vertex(-a/2, hTercio);
        vertex(a/2, hTercio);
        vertex(0, -2*hTercio);
        endShape(CLOSE);
      }

        if(sobre) {
        stroke(#E51515);
      }
      else {
        stroke(0);
      }
        switch(tipo){
        case 1:
          tipo1();
          break;
        case 2:
          tipo2();
          break;
        case 3:
          tipo3();
          break;
        case 4:
          tipo4();
          break;
        case 5:
          tipo5();
          break;
        case 6:
          tipo6();
          break;
        case 7:
          tipo7();
          break;
      }
    }
    popMatrix();
    calc();
  }

  void tipo1(){ // clsica: arco circular + segmento recto corto
    strokeWeight(grosor);
    arc(0, -2*hTercio, a, a, PI/3, TWO_PI/3);
    line(0, hTercio, 0, hTercio*0.7);
  }


  void tipo2(){ // quebrada: unin perpendicular quebrada al centro + trazo quebrado a la izquierda
    strokeWeight(grosor);
    beginShape(); 
    vertex(-a/4, -hTercio/2);
    vertex(0,0);
    vertex(a/4, -hTercio/2);
    endShape();

    beginShape();
    vertex(0, hTercio);
    vertex(0, hTercio*0.8);
    vertex(a*0.15, hTercio*0.5);
    endShape();
  }

  void tipo3(){ 
    strokeWeight(grosor);
    bezier(-a/4, -hTercio/2, 0, 0, 0, 0, a/4, -hTercio/2);
    arc(a/4, hTercio, a/2, a/2, PI*3, -PI/2);
  }

  void tipo4(){ // clsica fina: arco circular + arco de medio circulo
    strokeWeight(grosor);
    arc(0, -2*hTercio, a, a, PI/3, TWO_PI/3);
    noStroke();
    if(sobre){fill(#E51515);}else{fill(0);}
    arc(0, hTercio, grosor, grosor, PI, -TWO_PI);
    noFill();
  }
  
  void tipo5(){
    strokeWeight(grosor);
    strokeCap(ROUND);
    if(pdf){
       p.strokeCap(ROUND);
    }
    line(-a/4, -hTercio/2,a/4, -hTercio/2);
    line(0, hTercio, hTercio*0.15, hTercio*0.7);
    strokeCap(SQUARE);
    if(pdf){
      p.strokeCap(SQUARE);
    }
  }
  
  void tipo6(){
  strokeWeight(grosor);
  noFill();
      strokeCap(ROUND);
    if(pdf){
       p.strokeCap(ROUND);
    }
  arc(0, 4*hTercio, 2*a, 2*a, -PI*2/3, -PI/3);
      strokeCap(SQUARE);
    if(pdf){
      p.strokeCap(SQUARE);
    }
  arc(0, -2*hTercio, a, a, PI/3, TWO_PI/3);
  }

  void tipo7(){ //arco entre dos vrtices
    strokeWeight(grosor);
    noFill();
          strokeCap(ROUND);
    if(pdf){
       p.strokeCap(ROUND);
    }
    arc(0, 4*hTercio, 2*a, 2*a, -PI*2/3, -PI/3);
          strokeCap(SQUARE);
    if(pdf){
      p.strokeCap(SQUARE);
    }
  }

  void calc(){
    distanciaMouse = dist(xpos,ypos, mouseX, mouseY);
    if(distanciaMouse < sqrt(3)*a/6){
      sobre = true;
    }
    else {
      sobre = false;
    }
  }
}
